﻿--[[
--                                           TJS ©2015 through 2016 or (c)2015 through 2016
--                                                         by William B. Steele
--                                              [ Draewind <> Silver Hand US <> Alliance ]
--                                                         WOWUI@CompuBall.com
--   
--		This program is free software: you can redistribute it and/or modifyit under the terms of the GNU General Public License as published by
--		the Free Software Foundation, either version 3 of the License, or(at your option) any later version.
		
--		This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
--		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

--		You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>
--]]
--[[
--]]
--------------------------------------------------------------------------------------------------------------------------------
-- Initialization and Operation
--------------------------------------------------------------------------------------------------------------------------------

function TJS_HandleMSG(msg)
	local a = msg;
	if msg == "info" or msg == "i" then
		a="i";
	elseif msg == "all" or msg == "a" then
		a="a";
	elseif msg == "plan" or msg == "p" then
		a="p";
	elseif msg == "token" or msg == "t" then
		a="h";
	elseif msg == "hellbane" or msg == "hell" or msg == "bane" or msg == "h"  then
		a="h";
	elseif msg == "stalker" or msg == "stalk" or msg == "s" then
		a="s";
	elseif msg == "fang" or msg == "rep" or msg == "f" or msg == "r" then
		a="f";
	end
	return a;
end

function TJS_HandleMSG2(msg, msg2)
	if msg2 == "all" or msg2 == "a" then
		b="a";
	elseif msg2 == "day" or msg2 == "daily" or msg2 == "today" or msg2 == "d" then
		b="d";
	end
	if msg == "i" then
		if msg2 == "all" or msg2 == "a" then
			b="a";
		elseif msg2 == "plan" or msg2 == "p" then
			b="p";
		elseif msg2 == "token" or msg2 == "t" then
			b="h";
		elseif msg2 == "hellbane" or msg2 == "hell" or msg2 == "bane" or msg2 == "h"  then
			b="h";
		elseif msg2 == "stalker" or msg2 == "s" then
			b="s";
		elseif msg2 == "fang" or msg2 == "rep" or msg2 == "f" or msg2 == "r" then
			b="f";
		end
	end
	return b;
end

function TJS_InitializeVar()
	TJS["Info"] = {};
	TJS["Info"]["Player"] = UnitName("player");
	TJS["Info"]["Faction"] = UnitFactionGroup("player");
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffTJS Faction"..TJS["Faction"].."|r");
	TJS["Info"]["Realm"] = GetRealmName();
	TJS["Info"]["RealmID"] = string.gsub(TJS["Info"]["Realm"], " ", "");
	TJS["Info"]["RealmAbb"] = string.sub(TJS.Info.RealmID, 1, 3);
	TJS["Info"]["PlayerID"] = TJS["Info"]["Player"].."-"..TJS["Info"]["RealmID"];
	TJS["Info"]["ChatID"] = TJS.Info.Player.."-"..TJS.Info.RealmAbb;
	TJS["Info"]["ID"] = TJS["Info"]["PlayerID"].."-"..TJS["Info"]["Faction"];
	TJS["Info"]["Class"], TJS["Info"]["ClassFileName"] = UnitClass("player");
	TJS["Info"]["ClassColor"] = RAID_CLASS_COLORS[TJS.Info.ClassFileName];
	TJS["Info"]["PlayerColor"] = "|c"..TJS.Info.ClassColor.colorStr..TJS.Info.Player.."|r";
	TJS["Info"]["PlayerClassColor"] = "|c"..TJS.Info.ClassColor.colorStr..TJS.Info.Class.."|r";
	TJSLOADED = true;
--	TJS_SetTest();
end

function TJS_SetSelected(a, b)
	TJS_Create();
	local noskip = true;
	TJS_NoPoints = true;
	if a == "i" then
		TJS_PrintInfo(b);
		noskip = false;
	elseif a == "p" then
		TJS_SetPlanMarks(b);
	elseif a == "h" then
		TJS_SetHellMarks(b);
	elseif a == "s" then
		TJS_SetStalkMarks(b);
	elseif a == "f" then
		TJS_SetFangMarks(b);
	elseif a == "a" then
		TJS_SetPlanMarks(b);
		TJS_SetHellMarks(b);
		TJS_SetStalkMarks(b);
		TJS_SetFangMarks(b);
	else
		TJS_BadMessage(a);
		TJS_NoPoints = false;
		noskip = false;
	end
	if TJS_NoPoints then
		local warntext = "No Waypoints fit the Criteria."
		RaidNotice_AddMessage(RaidBossEmoteFrame, "<Tanaan Jungle Stalker>", ChatTypeInfo["RAID_BOSS_EMOTE"]);
		RaidNotice_AddMessage(RaidBossEmoteFrame, warntext, ChatTypeInfo["RAID_WARNING"]);
		DEFAULT_CHAT_FRAME:AddMessage("|cff71FB73<TJS>|r |cffFF0000No Waypoints Remaining for this selection.");
		TJS_Sound("error");
	elseif noskip then
		TJS_SetWaypoints();
	end
end

function TJS_SetPlanMarks(which)
	for n,a in pairs(TJS) do
		if a.class.plan then
			if a.flag.plan then
				if which == "a" then
					a.flag.SET = true;
					TJS_NoPoints = false;
			elseif which == "d" and not a.flag.today then
					a.flag.SET = true;
					TJS_NoPoints = false;
				end 
			else
				a.flag.SET = true;
				TJS_NoPoints = false;
			end
		end
	end
end

function TJS_SetStalkMarks(which)
	for n,a in pairs(TJS) do
		if a.class.stalk then
			if a.flag.achievement then
				if which == "a" then
					a.flag.SET = true;
					TJS_NoPoints = false;
				elseif which == "d" and not a.flag.today then
					a.flag.SET = true;
					TJS_NoPoints = false;
				end 
			else
				a.flag.SET = true;
				TJS_NoPoints = false;
			end
		end
	end
end

function TJS_SetHellMarks(which)
	for n,a in pairs(TJS) do
		if a.class.hellbane then
			if a.flag.today then
				if which == "a" then
					a.flag.SET = true;
					TJS_NoPoints = false;
				end 
			else
				a.flag.SET = true;
				TJS_NoPoints = false;
			end
		end
	end
end

function TJS_SetFangMarks(which)
	for n,a in pairs(TJS) do
		if a.class.fang then
			if a.flag.fangRep then
				a.flag.SET = true;
				TJS_NoPoints = false;
			else
				if which == "a" then
					a.flag.SET = true;
					TJS_NoPoints = false;
				end 
			end
		end
	end
end

function TJS_SetWaypoints()
	for n,a in pairs(TJS) do
		if a.flag.SET then
			TomTom:AddZWaypoint(a.c, a.z, a.x, a.y, a.text.text);
			if a.flag.inCave then
				c = a.cave;
				TomTom:AddZWaypoint(c.c, c.z, c.x, c.y, c.text);
			end
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff71FB73<Tanaan Jungle Stalker>|r Waypoints Set.");
	TJS_Sound("action");
end

--------------------------------------------------------------------------------------------------------------------------------
-- PRINTOUT
--------------------------------------------------------------------------------------------------------------------------------
local Color = "|cff71FB73";
local PrintHead = Color.."-----------<Tanaan Jungle Stalker>------------|r"
local PrintLine = Color.."------------------------------------------------------|r";

function TJS_PrintMenu()
	DEFAULT_CHAT_FRAME:AddMessage(PrintHead);
	DEFAULT_CHAT_FRAME:AddMessage(Color.."<TJS>|r  File: "..TJS_FILENUM.."|cff00ffff by Drae|r");
	DEFAULT_CHAT_FRAME:AddMessage(Color.."<TJS>|r  Player: "..TJS.Info.PlayerColor.." = "..TJS.Info.Realm.." <> "..TJS.Info.Faction.." <> "..TJS.Info.PlayerClassColor);
	DEFAULT_CHAT_FRAME:AddMessage(Color.."<TJS> Menu options:|r (use /tjs or /stalker)");
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage("");
	DEFAULT_CHAT_FRAME:AddMessage(Color.."p = PLAN, t = TOKEN, s = STALKER");
	DEFAULT_CHAT_FRAME:AddMessage(Color.."d = DAY (Daily or Today) - a = ALL");
	DEFAULT_CHAT_FRAME:AddMessage("");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r = Prints this menu (Force Update).");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 info|r = Print Plan and Token Status (|cff00FF00Done|r - |cffFF0000Undone|r).");
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 s|r = Mark STALKER rares NEEDED.");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 s d|r = Mark STALKER rares not killed today.");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 s a|r = Mark ALL STALKER rares.");
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 p|r = Mark PLAN rares NEEDED.");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 p d|r = Mark PLAN rares not killed today.");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 p a|r = Mark ALL 7 PLAN rares.");
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 f|r = FANG'RILA - Mark rares that will award Saberstalker Rep.");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 f d|r = Mark FANG'RILA rares not killed today.");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 f a|r = Mark ALL FANG'RILA rares.");
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 h|r = Mark HELLBANE rares not killed today.");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 h a|r = Mark ALL 4 HELLBANE rares.");
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 a|r = Same as /tjs p + /tjs t + /tjs s");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 a a|r = Same as /tjs p a + /tjs t a + /tjs s a");
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	TJS_UpdateFlags();
end

function TJS_PrintInfo()
	TJS_NoPoints = false;
	DEFAULT_CHAT_FRAME:AddMessage(PrintHead);
	DEFAULT_CHAT_FRAME:AddMessage(Color.."Shipyard Plan Rares:|r");
	for n,a in pairs(TJS) do
		if a.class.plan then
			if a.flag.plan then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00FF00"..n.."|r");
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cffFF0000"..n.."|r");
			end
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage(Color.."Hellbane Rares:|r");
	for n,a in pairs(TJS) do
		if a.class.hellbane then
			if a.flag.today then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00FF00"..n.."|r");
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cffFF0000"..n.."|r");
			end
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
end

function TJS_Sound(sound)
	if sound == "error" then PlaySound("igQuestFailed", "Master") end
--	if sound == "error" then PlaySound("RaidWarning", "Master") end
--	if sound == "action" then PlaySound("igPlayerInvite", "Master"); end
	if sound == "action" then PlaySound("LEVELUPSOUND", "master"); end
end

function TJS_BadMessage(message)
	TJS_Sound("error");
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage(Color.."<TJS>|r|cffFA5151 Unable to understand command: |cffffff00"..message.."|r");
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
end

